workflow:
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH # only run on master

# This folder is cached between builds
# https://docs.gitlab.com/ee/ci/yaml/index.html#cache
.node_cache: &node_cache
  key:
    files:
      - package-lock.json
  paths:
    - node_modules/

download_latest:
  stage: build
  image: node:20
  before_script:
    - eval $(ssh-agent)
    # SSH key generated locally and added to to deploy keys
    - echo "$CI_DATA_HISTORY_SSH_PRIVATE_KEY" | ssh-add -
    - mkdir -p ~/.ssh
    - ssh-keyscan gitlab.com >> ~/.ssh/known_hosts
    - git config --global user.email "gitlab-ci[bot]@users.noreply.gitlab.com"
    - git config --global user.name "gitlab-ci[bot]"

  script:
    - npm install
    - npm run _ci-download
  cache: 
    <<: *node_cache

site_bundle:
  stage: build
  image: node:20
  cache: 
    <<: *node_cache
    policy: pull
  needs:
    - download_latest # used to get node cache
  script:
    - npm run gen-site out/site
  artifacts:
    paths:
      - out/site
    expire_in: 1 day
  rules:
    - if: $CI_PIPELINE_SOURCE != "schedule" # Don't run because of schedule

site_build:
  stage: deploy
  trigger: hqurve-site/timetable/site
  needs:
    - site_bundle
  rules:
    - if: $CI_PIPELINE_SOURCE != "schedule" # Don't run because of schedule
